using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DataBindingFundamentalsSample {
  public partial class SimpleBindingAndItemDataSourcesForm : Form {

    RaceCarDriver raceCarDriver = new RaceCarDriver("M. Schumacher", 500);
    
    public SimpleBindingAndItemDataSourcesForm() {
      InitializeComponent();

      // Bind the Name and Wins properties to the name and wins text boxes
      Binding nameBinding = new Binding("Text", raceCarDriver, "Name");
      // Add the binding to the UI element
      this.nameTextBox.DataBindings.Add(nameBinding);

      // There is a shortcut on many controls.
      this.winsTextBox.DataBindings.Add("Text", this.raceCarDriver, "Wins");  
    }

    private void addWinButton_Click(object sender, EventArgs e) {
      // Causes the RaceCarDriver object's WinsChanged event to fire, 
      // which is used by the data binding infrastructure
      // to keep the text boxes up to date
      ++this.raceCarDriver.Wins;
    }
  }
}